// Conway's Game of Life!

atom icon='Icons.dmi'

client
	view="50x50"


world
	icon_size=32
	tick_lag=0.5

mob
	var
		automationToggle=0		// handles if the automation is in process
		delayTime	=	3		// the delay time per each Automata tick

	Login()
		loc=locate(100,100,1)
		RenderPatterns()

obj/Cell

	Dead
		icon_state="dead"


	Alive
		icon_state="alive"

	Virus
		icon_state="virus"



	// Mouse Functions

	Click(location,control,params)

		if("right" in params2list(params))
			for(var/obj/Cell/Dead/D in oview(rand(2,6),src))
				if(prob(70)) D.Transform()

			Transform()

		else if("shift" in params2list(params))
			for(var/obj/Cell/Dead/D in oview(rand(7,12),src))
				D.Transform()

			Transform()

		else
			Transform()




	proc/Transform(virus)
		// Dead --> alive ; Alive --> dead

		if(virus)
			var/obj/Cell/Virus/A=new/obj/Cell/Virus
			A.loc=locate(x,y,z)

			del(src)

		if(istype(src,/obj/Cell/Dead))

			// toggle a dead cell into an alive cell

			var/obj/Cell/Alive/A=new/obj/Cell/Alive
			A.loc=locate(x,y,z)
			del(src)

		else

			// toggle an alive cell or infected cell into a dead cell

			var/obj/Cell/Dead/A=new/obj/Cell/Dead
			A.loc=locate(x,y,z)

			del(src)

mob/verb
	ToggleAutomation()
		if(automationToggle)
			automationToggle=0
			src<<"The automation has been halted."
		else
			automationToggle=1
			src<<"The automation has been activated."
			CellularAutomata()

	ClearMap()
		set name="Clear"
		Clear()
		world<<"Map cleared."

	Virus()
		set name="Introduce Virus"
		switch(input("Are you sure you wish to introduce a virus onto the map? You will not be able to undo any of the damages.") in list("Yes","No"))
			if("Yes")

				var/list/Choices=list()
				var/list/Choices2=list()

				// choose an infection point
				var/obj/infectpoint=new/obj

				for(var/obj/Cell/Alive/A in world)
					if(A.z==1)
						if(Choices2.len>=20) break
						Choices2.Add(A)

				if(!Choices2.len)
					src<<"ERR: Alive cell(s) not located."
					return

				var/obj/Cell/Alive/chosen=pick(Choices2)
				infectpoint.loc=locate(chosen.x,chosen.y,1)


				for(var/obj/Cell/Alive/A in view(15,infectpoint))
					if(Choices.len>=20) break

					Choices.Add(A)


				for(var/i=1,i<=rand(2,20),i++)

					if(Choices.len)
						var/obj/Cell/Alive/A=pick(Choices)
						Choices.Remove(A)

						var/obj/Cell/Virus/V=new/obj/Cell/Virus
						V.loc=locate(A.x,A.y,A.z)

						del(A)

					else break

	PopularPatterns()
		set name="View Popular Patterns"
		ViewPatterns()





	SetSize()
		set name="Set Zoom Size"
		switch(input("What magnitude of zoom do you want? 1 = 16x16 (i.e. the closest zoom)") in list(1,2,3,4,5,6))

			if(1)
				client.view="16x16"

			if(2)
				client.view="20x20"

			if(3)
				client.view="25x25"

			if(4)
				client.view="35x35"

			if(5)
				client.view="50x50"

			if(6)
				client.view="60x60"

	DefineSize()
		set name="Define Zoom Size"
		var/X=input("Client.view max x axis (warning: this may completely ruin your display, but can allow a greater overall resolution)") as num|null
		if(X && X>1)
			var/Y=input("Client.view max y axis (warning: this may completely ruin your display, but can allow a greater overall resolution)") as num|null

			if(Y && Y>1)
				client.view="[X]x[Y]"

	DefineDelay()
		set name="Define Delay Time"
		var/delay=input("How many ticks (1/10th of a second) in delay do you want between automata cycles?") as num|null
		if(delay && delay>0)

			delayTime=delay


	ChangeRules()
		set name="Change the Rules!"
		automationToggle=0

		var/one=input("Rule 1: Any alive cell with fewer than \"x\" alive neighbors dies. What is x? (default: 2)") as num|null
		if(one && one>0)

			alert("Rule 2: Any cell with an amount of neighbors exactly between Rule 1 and Rule 3's respective values survives the next tick/generation. (default: 2 and 3)")
			var/three=input("Rule 3: Any alive cell with more than \"x\" alive neighbors dies. What is x? (default: 3)") as num|null

			if(three && three>0)

				var/four=input("Rule 4: Any dead cell with exactly \"x\" alive neighbors becomes alive. What is x? (default: 3)") as num|null

				if(four && four>0)

					rule1=one
					rule3=three
					rule4=four
					alert("The changes have been made. Depending on the integers you previously input, the cellular automata may output some wacky readings! Beware!")













